package kpalin.alabra;

public class PawnTransfer {
  Piece newPiece;
  boolean available=false;

  
  public synchronized Piece get() {
    while (available == false) {
      try {
	// wait for Producer to put value
	wait();
      } catch (InterruptedException e) {
      }
    }
    available = false;
    // notify Producer that value has been retrieved
    notifyAll();
    return newPiece;
  }

  public synchronized void put(Piece value) {
    while (available == true) {
      try {
	// wait for Consumer to get value
	wait();
      } catch (InterruptedException e) {
      }
    }
    newPiece = value;
    available = true;
    // notify Consumer that value has been set
    notifyAll();
  } 
}
