package kpalin.alabra;
import java.awt.*;
import java.awt.event.*;

/** This class provides menus for application.
    Menus: file

    @author Kimmo Palin
    @see AppForm
    @see FileMenu
*/

public class ChessAppMB extends MenuBar {

  /** This listens menuactions. This is a Weird Hack(tm).
  */
  private ChessMenuListener menuListen;

  /** File menu.
   */
  private FileMenu fmenu;

  /** Nothing special here. All interresting stuf is in deeper classes.
      This only adds the menus to the menubar.

      @param app Parent AppForm so we can control it.
   */
  ChessAppMB(AppForm app) {

    menuListen=new ChessMenuListener(app);
    fmenu=new FileMenu(menuListen);
    add(fmenu);
  }
}
