package kpalin.alabra;
import java.awt.*;
import java.awt.event.*;

/** This joins menuitems as filemenu
 @author Kimmo Palin
*/

public class FileMenu extends Menu {
  /** Name of the menu.
   */
  final static String name="File";

  /** Creates the menu and adds menuitems to it.
   */
  FileMenu(ActionListener l) {
    super(name);
    add(new FileNew(l));
    add(new FileLoad(l));
    add(new FileSaveAs(l));
    add(new FileSave(l));
    addSeparator();
    add(new FileExit(l));
  }
}

