package kpalin.alabra;
import java.awt.*;
import java.awt.event.*;

/** The pawn promotion dialog.
    @see ChessPlay
    @author Kimmo Palin
*/

public class PawnPromote extends Frame implements MouseListener{
  /** The title of the dialog.
   */
  static final String TITLE="Pawn Promotion";


  /** Creates new PawnPromotion dialog.
      @param side The side who is promoting (black or white).
   */
  PawnPromote(int side) {
    setTitle(TITLE);
    setLayout(new GridLayout(4,1));
    Dimensiond dim=new Dimension(32,32);

    add(new PromotionImage(Piece.QUEEN,side),d,this);
    add(new PromotionImage(Piece.ROOK,side),d,this);
    add(new PromotionImage(Piece.BISHOP,side),d,this);
    add(new PromotionImage(Piece.KNIGHT,side),d,this);
    //This is for netscape
    resize(4*d.width,d.height);
    //setSize(4*d.width,d.height);

  }

  public void mouseEntered(MouseEvent e) { return; }
  public void mouseExited(MouseEvent e) { return; }
  public void mousePressed(MouseEvent e) { return; }
  public void mouseReleased(MouseEvent e) { return; }

  /** This one handles the ui.
   */
  public void mouseClicked(MouseEvent e) {
    piece=((PromotionImage)e.getComponent()).p;
  }
}
